resource NDeclPlurGer = NDeclGer ** {

-- Regel 1 Maskulina und Neutra bilden den Plural auf -e oder sind
--   endungslos (gemäß Regel 3)
-- Regel 2 Maskulina, die auf -e enden, und Feminina bilden
--   den Plural auf -en bzw.~auf -n (gemäß Regel 3).
-- Regel 3 Bei "`e-haltigem"' Wortausgang (-e oder
--   -e+Konsonant) und beim Suffix -lein wird die Endung
--   -e getilgt und die Endung -en zu -n gekürzt.
-- Regel 4 Kernwörter, die auf klingenden Vokal enden, bilden den
--   Plural mit -s.
-- Regel 5 Die Endung -er ist nicht möglich bei Substantiven,
--   die auf -e oder -e+Konsonant enden.

oper ePlural : Case => Str = table Case ["e"; "e"; "en"; "e"]; 
               -- Tage, Tage, Tagen, Tage
     nullPlural : Case => Str = table Case [""; ""; "n"; ""]; 
               -- Fernseher, Fernseher, Fernsehern, Fernseher
     enPlural : Case => Str = table Case ["en"; "en"; "en"; "en"]; 
               -- Tafeln, Tafeln, Tafeln, Tafeln, 
               -- Frauen, Frauen, Frauen, Frauen, 
     nPlural : Case => Str = table Case ["n"; "n"; "n"; "n"]; 

     erPlural : Case => Str = table Case ["er"; "er"; "ern"; "er"]; 
               -- Häuser, Häuser, Häusern, Häuser
               -- Väter, Väter, Vätern, Väter (Wetter) ??? r im Stamm?
     sPlural : Case => Str = table Case ["s"; "s"; "sn"; "s"]; 
               -- Handys, Handys, Handys, Handys
               -- Uhus, Uhus, Uhus, Uhus

     declPl : Str -> Gender -> N = \nomSg, g -> 
               case <nomSg, g> of {
                    <x+"e", Masc> => regel2 nomSg g ;
                    <_, Masc|Neut> => regel1 nomSg g ;
                    _              => { s = \\n,c => nomSg + "_TODO" ;
                                        g = g }
               } ;

     regel1 : Str -> Gender -> N ;
     regel1 nomSg g = { s = table { Pl => table { c => (regel3 nomSg)!c } ;
                                    Sg => table { c => nomSg } } ; -- TODO sg-Endungen
                        g = g } ;

     regel3 : Str -> Case => Str = \nomSg -> 
              case nomSg of { x+"e" => table { c => nomSg + nullPlural!c } ;
                              x+"e"+ #consonant => 
                                       table { c => nomSg + nullPlural!c } ;
                              _     => table { c => nomSg + ePlural!c }  
                            } ;

    consonant : pattern Str = #( "m" | "n" | "l" | "r" ) ; -- ergänzen

}
